#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		msgbus		messagebus
%define		_drun		%{_var}/run
#-----------------------------------------------------------------------------
Name		:	dbus
Version		:	1.15.4
Release		:	17.2.0.rel%{?dist}
Summary		:	D-BUS message bus
Group		:	System Environment/Libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2+ or AFL
URL		:	https://dbus.freedesktop.org/releases/dbus/

Source0		:	%{name}-%{version}.tar.xz
Source1		:	%{name}-ok_addon.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	doxygen
BuildRequires	:	elogind-devel
BuildRequires	:	xorg-libX11

Requires	:	/usr/sbin/useradd, /usr/sbin/userdel
Requires	:	/usr/sbin/groupadd, /usr/sbin/groupdel
Requires	:	lfs-bootscripts
Requires	:	chkconfig

Obsoletes	:	dbus-bootstrap	<= %{version}
#-----------------------------------------------------------------------------
%description
D-Bus is a message bus system, a simple way for applications to talk to one
another. D-Bus supplies both a system daemon (for events such as "new hardware 
device added" or "printer queue changed") and a per-user-login-session daemon
(for general IPC needs among user applications). Also, the message bus is built
on top of a general one-to-one message passing framework, which can be used by
any two applications to communicate directly (without going through the message
bus daemon). 

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)

#=============================================================================
%package		common
Summary		:	D-BUS message bus configuration

#-----------------------------------------------------------------------------
BuildArch	:	noarch
#-----------------------------------------------------------------------------
%description		common
The %{name}-common package provides the configuration and
setup files for D-Bus implementations to provide a System
and User Message Bus.

#-----------------------------------------------------------------------------
%files			common
%doc AUTHORS NEWS README
%defattr(-,root,root,-)
%config %{_sysconfdir}/%{name}-1/session.conf
%config %{_sysconfdir}/%{name}-1/system.conf
%{_datadir}/%{name}-1/session.conf
%{_datadir}/%{name}-1/system.conf

#=============================================================================
%package		devel
Summary		:	Development files for D-BUS

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
This package contains libraries and header files
needed for developing software that uses D-BUS.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}-1.0/%{name}/*.h
%{_libdir}/%{name}-1.0/include/*
%{_libdir}/lib%{name}-1.so
%{_libdir}/pkgconfig/%{name}-1.pc
%{_libdir}/cmake/DBus1/*.cmake
%{_datadir}/xml/%{name}-1/*.dtd
%{_datadir}/xml/%{name}-1/catalog.xml


#=============================================================================
%package		doc
Summary		:	Developer documentation for D-BUS

#-----------------------------------------------------------------------------
Requires	:	%{name}-daemon	= %{version}-%{release}

BuildArch	:	noarch

#-----------------------------------------------------------------------------
%description		doc
This package contains developer documentation for D-Bus along with
other supporting documentation such as the introspect dtd file.

#-----------------------------------------------------------------------------
%files			doc
%defattr(-,root,root,-)
%{_defaultdocdir}/%{name}-%{version}/*.html
%{_defaultdocdir}/%{name}-%{version}/*.png
%{_defaultdocdir}/%{name}-%{version}/diagram.svg
%{_defaultdocdir}/%{name}-%{version}/dbus.devhelp2
%{_defaultdocdir}/%{name}-%{version}/api/*.css
%{_defaultdocdir}/%{name}-%{version}/api/*.html
%{_defaultdocdir}/%{name}-%{version}/api/*.js
%{_defaultdocdir}/%{name}-%{version}/api/*.png
%{_defaultdocdir}/%{name}-%{version}/api/*.svg
%{_defaultdocdir}/%{name}-%{version}/examples/example-*.conf
%{_defaultdocdir}/%{name}-%{version}/examples/GetAllMatchRules.py
%{_defaultdocdir}/%{name}-%{version}/system-activation.txt

#=============================================================================
%package		daemon
Summary		:	D-BUS message bus

#-----------------------------------------------------------------------------
Requires	:	%{name}-common	= %{version}-%{release}
Requires	:	%{name}-libs	= %{version}-%{release}
Requires	:	%{name}-tools	= %{version}-%{release}

Requires	:	shadow

#-----------------------------------------------------------------------------
%description		daemon
D-BUS is a system for sending messages between applications.
It is used both for the system-wide message bus service,
and as a per-user-login-session messaging facility.

#-----------------------------------------------------------------------------
%files			daemon
%defattr(-,root,root,-)
%attr (0750,-,-) %{_sysconfdir}/rc.d/init.d/%{name}
%attr (04750,root,%{msgbus}) %{_libexecdir}/%{name}-daemon-launch-helper
%dir %{_localstatedir}/lib/dbus/
%{_bindir}/%{name}-daemon
%{_bindir}/%{name}-cleanup-sockets
%{_bindir}/%{name}-run-session
%{_bindir}/%{name}-test-tool
%{_mandir}/man1/%{name}-cleanup-sockets.1.gz
%{_mandir}/man1/%{name}-daemon.1.gz
%{_mandir}/man1/%{name}-run-session.1.gz
%{_mandir}/man1/%{name}-test-tool.1.gz

#-----------------------------------------------------------------------------
%pre		daemon
if [ "$1" = 1 ]; then
  if [ ! $(getent group %{msgbus}) ]; then
    /usr/sbin/groupadd				\
	-K GID_MIN=10				\
	-K GID_MAX=49				\
	%{msgbus} 
    /usr/sbin/useradd 				\
	-r					\
	-c "D-Bus Message Daemon User"		\
	-K SYS_UID_MIN=10			\
	-K SYS_UID_MAX=49			\
	-g %{msgbus}				\
	-s /bin/false				\
	-d %{_drun}/%{name}			\
	%{msgbus}
    fi
  fi

#-----------------------------------------------------------------------------
#after upgrade or remove
%preun		daemon
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del %{name}
  /usr/sbin/userdel %{msgbus}
  (
  /bin/echo -n "%{name}-daemon-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

#-----------------------------------------------------------------------------
%post			daemon
%{_sbindir}/chkconfig --add %{name}
%{_sysconfdir}/rc.d/init.d/%{name} condrestart > /dev/null 2>&1 || :

#=============================================================================
%package		tools
Summary		:	D-BUS Tools and Utilities

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		tools
Tools and utilities to interact with a running
D-Bus Message Bus, provided by the reference
implementation.

#-----------------------------------------------------------------------------
%files			tools
%defattr(-,root,root,-)
%{_bindir}/%{name}-send
%{_bindir}/%{name}-monitor
%{_bindir}/%{name}-update-activation-environment
%{_bindir}/%{name}-uuidgen
%{_mandir}/man1/%{name}-monitor.1.gz
%{_mandir}/man1/%{name}-send.1.gz
%{_mandir}/man1/%{name}-update-activation-environment.1.gz
%{_mandir}/man1/%{name}-uuidgen.1*

#=============================================================================
%package		libs
Summary		:	Libraries for accessing D-BUS

#-----------------------------------------------------------------------------
Obsoletes	:	dbus-bootstrap	<= %{version}
#-----------------------------------------------------------------------------
%description		libs
This package contains lowlevel libraries for accessing D-BUS.

#-----------------------------------------------------------------------------
%files			libs
%defattr(-,root,root,-)
%license COPYING
%{_libdir}/lib%{name}-1.so.3*

#=============================================================================
%package		x11
Summary		:	X11-requiring add-ons for D-BUS

#-----------------------------------------------------------------------------
Requires	:	%{name}-daemon	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		x11
D-BUS contains some tools that require Xlib
to be installed, those are in this separate
package so server systems need not install X.

#-----------------------------------------------------------------------------
%files			x11
%defattr(-,root,root,-)
%{_bindir}/%{name}-launch
%{_mandir}/man1/%{name}-launch.1.gz


#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

%{__tar} xf %{SOURCE1}


./configure							\
        --prefix=%{_prefix}					\
        --includedir=%{_includedir}				\
	--exec-prefix=%{_exec_prefix}				\
	--libexecdir=%{_libexecdir}				\
        --sysconfdir=%{_sysconfdir}				\
        --sbindir=%{_sbindir}					\
	--mandir=%{_mandir}					\
	--libdir=%{_libdir}					\
	--infodir=%{_infodir}					\
	--docdir=%{_defaultdocdir}/%{name}-%{version}		\
	--localstatedir=%{_var}					\
        --disable-static					\
	--enable-doxygen-docs					\
	--enable-xml-docs					\
	--with-console-auth-dir=%{_drun}/console		\
	--with-system-pid-file=%{_drun}/dbus/pid		\
	--with-system-socket=%{_drun}/dbus/system_bus_socket	\
	--disable-systemd					\
	--disable-selinux					\
	--disable-apparmor					\
	--enable-debug=yes					\
	--enable-qt-help=no					\
	--enable-verbose-mode					\
	--enable-x11-autolaunch					\
	--with-init-scripts=redhat				\


%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
%check
%{__make} check

#-----------------------------------------------------------------------------
#installing program
%install

%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install

%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} %{name}-ok_addon/%{name} %{buildroot}%{_sysconfdir}/rc.d/init.d


#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
